import * as React from "react";
import { isTV } from "@applicaster/zapp-react-native-utils/reactUtils";
import { useNavigation } from "@applicaster/zapp-react-native-utils/reactHooks/navigation";
import { ScreenContextProvider } from "../../Contexts/ScreenContext";

import Mobile from "./Mobile";
import TV from "./TV";

export default function Layout(props) {
  const { currentRoute: pathname } = useNavigation();

  if (isTV()) {
    return (
      <ScreenContextProvider pathname={pathname}>
        <TV {...props} />
      </ScreenContextProvider>
    );
  } else {
    return <Mobile {...props} />;
  }
}
